Attribute VB_Name = "Module1"
'Print text will be used to print the text in the Picture Box...

Option Explicit

Private Const ANSI_CHARSET = 0                                              ' ANSI character set
Private Const CLIP_CHARACTER_PRECIS = 0                                     ' clip one character at a time, OR'd
Private Const CLIP_LH_ANGLES = 0                                            ' Needed for tilted fonts, OR'd
Private Const FONT_CLIP_PRECISION = CLIP_LH_ANGLES
Private Const FONT_ITALIC = 0                                               ' Italics T/F
Private Const FONT_NAME = "Arial"                                           ' typeface/font name
Private Const FONT_OUTPUT_PRECISION = 0                                     ' don't care
Private Const FONT_ORIENTATION = 0                                          ' don't care, Windows assumes same as escapement
Private Const FONT_PITCH_N_FAMILY = 0                                       ' don't care, let font mapper pick easily
Private Const FONT_QUALITY = 0                                              ' don't care, let font mapper pick easily
Private Const FONT_STRIKEOUT = 0                                            ' Strikeout T/F
Private Const FONT_UNDERLINE = 0                                            ' Underline T/F
Private Const FW_BOLD = 700                                                 ' Bold weight
Private Const FW_DONTCARE = 0                                               ' don't care, let font mapper use default weight
Private Const FW_NORMAL = 800                                              ' Normal weight
Private Const FONT_WEIGHT = FW_NORMAL
Private Const FONT_WIDTH = 0                                               ' don't care, let font mapper pick according to height

Public Const SRCCOPY  As Long = &HCC0020

'---API Functions that we need ---
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, _
   ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, _
   ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

Private Declare Function BeginPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal e As Long, ByVal o As Long, ByVal W As Long, ByVal i As Long, ByVal U As Long, ByVal S As Long, ByVal c As Long, ByVal OP As Long, ByVal cp As Long, ByVal Q As Long, ByVal PAF As Long, ByVal f As String) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function EndPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function FillPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function RestoreDC Lib "gdi32" (ByVal hdc As Long, ByVal nSavedDC As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function SetROP2 Lib "gdi32" (ByVal hdc As Long, ByVal nDrawMode As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function SaveDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long


'
' Obj is a picture object, such as a PictureBox
' X and Y are the starting position of the text in Pixels
' FontSize is the character height in Pixels
' Txt is the text string to output
' DrawMode is the Raster Operation, e.g., vbCopyPen, vbNotXorPen
' Color is the text color, anything but vbWhite
' Many more font attributes could be variables, replacing constants in CreateFont() below
'
Public Sub PrintText(Obj As Object, _
                    ByRef X As Single, _
                    ByRef Y As Single, _
                    ByRef Fontsize As Long, _
                    ByVal Txt As String, _
                    ByVal DrawMode As DrawModeConstants, _
                    ByVal color As Long _
                    )
    Dim savedDC As Long
    Dim new_font As Long, old_font As Long
    Dim dl As Long                                                          'dummy to receive API returns
    Dim iROP2 As Long
    Dim usebrush As Long, oldbrush As Long
    
    If Fontsize < 0 Then Exit Sub                                           'guard against nonsense
    savedDC = SaveDC(Obj.hdc)                                               'save Device Context
    
    
    
    new_font = CreateFont(Fontsize, FONT_WIDTH, _
        0, FONT_ORIENTATION, _
        FONT_WEIGHT, FONT_ITALIC, FONT_UNDERLINE, FONT_STRIKEOUT, _
        ANSI_CHARSET, FONT_OUTPUT_PRECISION, FONT_CLIP_PRECISION, _
        FONT_QUALITY, FONT_PITCH_N_FAMILY, FONT_NAME)                       'create the  font
    old_font = SelectObject(Obj.hdc, new_font)                              'select the new font, and save the old font (Important)!
    'set background mode to draw text with a transparent background
    '...obj.FontTransparent does NOT work for this
    'dl = SetBkMode(Obj.hdc, TRANSPARENT)
    dl = BeginPath&(Obj.hdc)                                                'start saving graphics output into a Path
    dl = TextOut(Obj.hdc, X, Y, Txt, Len(Txt))                              'draw the text into the Path ... obj.Print does NOT work for this
    dl = EndPath(Obj.hdc)                                                   'finish saving to the Path
    dl = SelectObject(Obj.hdc, old_font)                                    'restore the original font
    dl = DeleteObject(new_font)                                             'free font resources (important!)
    '... if we wanted to transform the Path points we could do it here
    '... see MSDN for the demo C program TEXTFX.EXE
    'now draw and fill the saved path
    '... we don't get any outlines with just FillPath()
    iROP2 = SetROP2(Obj.hdc, DrawMode)                                      'set the drawmode, e.g., R2_NOTXORPEN/vbNotXorPen for Xor drawing
    usebrush = CreateSolidBrush(color)                                      'set the text color, create a brush to for the text areas
    oldbrush = SelectObject(Obj.hdc, usebrush)                              'select the new brush, and save the old brush (Important!)
    dl = FillPath(Obj.hdc)                                                  'draw the text saved in the Path, without outlines
    dl = SetROP2(Obj.hdc, iROP2)                                            'restore the original draw mode
    dl = SelectObject(Obj.hdc, oldbrush)                                    'restore the original Brush
    dl = DeleteObject(usebrush)                                             'free Brush resources (Important!)
    dl = RestoreDC(Obj.hdc, savedDC)                                        'restore the original Device Context (Important)
End Sub




